﻿'
' Copyright (c) 2021, MindFusion LLC - Bulgaria.
'


''' <summary>
''' Interaction logic for MainWindow.xaml
''' </summary>
Partial Public Class MainWindow
	Inherits Window
	Public Sub New()
		InitializeComponent()

		form.MeasureUnit = GraphicsUnit.Point
	End Sub

	Private Sub Window_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs)
		palette.SelectedIndex = 0

		form.BackBrush = Brushes.LightGray

		form.Behavior = Behavior.[Custom]
		form.CustomNodeType = GetType(Button)
	End Sub

	Private Sub form_NodeCreated(ByVal sender As Object, ByVal e As MindFusion.Diagramming.Wpf.NodeEventArgs)
		If form.CustomNodeType Is GetType(Button) Then
			Dim button As Button = DirectCast(e.Node.UIElement, Button)
			button.FontSize = 11
			button.Padding = New Thickness(0.5)
			button.Content = "Button" & form.Nodes.Count.ToString()
		End If
	End Sub

	Private Sub palette_SelectionChanged(ByVal sender As Object, ByVal e As SelectionChangedEventArgs)
		Select Case palette.SelectedIndex
			Case 0
				form.CustomNodeType = GetType(Button)
				Return
			Case 1
				form.CustomNodeType = GetType(TextBox)
				Return
			Case 2
				form.CustomNodeType = GetType(Label)
				Return
		End Select
	End Sub

	Private Sub form_NodeActivated(ByVal sender As Object, ByVal e As NodeEventArgs)
		If e.Node IsNot Nothing Then
			propGrid.SelectedObject = e.Node.UIElement
		End If
	End Sub

	Private Sub btnSave_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
		Dim sfd As New Microsoft.Win32.SaveFileDialog()

		If sfd.ShowDialog() = True Then
			form.SaveToXml(sfd.FileName)
		End If
	End Sub

	Private Sub btnLoad_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
		Dim ofd As New Microsoft.Win32.OpenFileDialog()

		If ofd.ShowDialog() = True Then
			Try
				form.LoadFromXml(ofd.FileName)
			Catch
				MessageBox.Show("Invalid file format.")
			End Try
		End If
	End Sub

	Private Sub form_InitializeNode(ByVal sender As Object, ByVal e As NodeEventArgs)
		Dim node As DiagramNode = TryCast(e.Node, DiagramNode)
		If node IsNot Nothing Then
			Dim tbox As TextBox = TryCast(node.UIElement, TextBox)
			If tbox IsNot Nothing Then
				tbox.FontSize = 11
				tbox.Padding = New Thickness(0.5)
				tbox.TextWrapping = TextWrapping.Wrap
			End If

			Dim label As Label = TryCast(node.UIElement, Label)
			If label IsNot Nothing Then
				label.FontSize = 11
				label.Content = "Label"
				label.Padding = New Thickness(0.5)
			End If
		End If
	End Sub
End Class